<?php
#$Id: functions.inc.php,v 1.1.1.1 2003/05/23 18:47:07 ryan Exp $
function connectdb() {
    global $dbserver;
    global $dbuser;
    global $dbpass;
    global $database;
    mysql_connect("$dbserver", "$dbuser", "$dbpass");
    mysql_select_db("$database");
}

function onError($errno, $errstr, $errfile='', $errline=''){

    $current_date_time = date("M-d-y H:i:s");
    global $siteName;
    global $webmasterEmail;
    $writefile = "logs/error.log";
    $headers = "From: $siteName Error Mailer <$webmasterEmail>\r\n";
    $headers .= "X-Sender: <$webmasterEmail>\r\n";
    $headers .= "X-Mailer: PHP\r\n";
    $headers .= "X-Priority: 1\r\n";
    $headers .= "Reply-To: $webmasterEmail\r\n";
    if ($errno == FATAL){
        $message = "FATAL [$errno] $errstr";
        $message .= " :: ".$errline." :: ".$errfile." :: " . time() . "\r\n";
        $message .= ", PHP ".PHP_VERSION." (".PHP_OS.")\r\n";
        $die=2;
    }
    else if ($errno == ERROR){
        $message =  "ERROR [$errno] $errstr :: ".$errline." :: ".$errfile." :: " . time() . "\r\n";
        $die=1;
    }
    else if ($errno == WARNING || $errno == "2"){
        $message = "WARNING [$errno] $errstr :: ".$errline." :: ".$errfile." :: " . time() . "\r\n";
        $die=1;
    }
    //else {
    //    $message = "Unkown error type: [$errno] $errstr :: ".$errline." :: ".$errfile." :: " . time() . "\r\n";
    //}
    if ($die == 1 || $die == 2){
        if (file_exists($writefile)){ $fp = fopen( $writefile, 'a'); }
        else { touch($writefile); $fp = fopen( $writefile, 'w' ); }
        fwrite( $fp, $message);
        fclose($fp);
        $message .= "\r\nDo Not Reply to this Message";
        mail($addressemail, "An Error Occured ($siteName)", $message, $headers);

        if ($die == 2){
            $diemessage = "<font face=arial size=2 color=red>An error has occured.  It has been loged and the Webmaster has been notified.</font><p>";
            $diemessage .= "<font face=arial size=2>$errstr</font>";

            die($diemessage);
        }
    }
}

function addLog($action, $user, $id){

    $date = time();
    $writefile = "logs/event.log";
    if (file_exists($writefile)){ $fp = fopen( $writefile, 'a'); }
    else { touch($writefile); $fp = fopen( $writefile, 'w' ); }
    $message .= "$date :: $action :: $user :: $id\r\n";
    fwrite( $fp, $message);
    fclose($fp);
}


function click($text) {

    $ret = " " . $text;
    $ret = preg_replace("#([\n ])([a-z]+?)://([^, \n\r]+)#i", "\\1<a href=\"\\2://\\3\" target=\"_blank\">\\2://\\3</a>", $ret);
    $ret = preg_replace("#([\n ])www\.([a-z0-9\-]+)\.([a-z0-9\-.\~]+)((?:/[^, \n\r]*)?)#i", "\\1<a href=\"http://www.\\2.\\3\\4\" target=\"_blank\">www.\\2.\\3\\4</a>", $ret);
    $ret = preg_replace("#([\n ])([a-z0-9\-_.]+?)@([^, \n\r]+)#i", "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>", $ret);
    $ret = substr($ret, 1);
    return($ret);
}

function covertText($text){

    $text = str_replace("<", "&lt;", $text);
    $text = str_replace(">", "&gt;", $text);
    $text = stripslashes($text);
    return $text;

}

function optimizeMySQL($userinfo){

    global $database;
    $tables = mysql_list_tables($database);
    while (list($table_name) = mysql_fetch_array($tables)) {
        mysql_query("optimize table $table_name");
    }
    addLog("Optimize MySQL", $userinfo[0], '');
}

function createMenuSelectForm($menu_id1){

    $cat = "<script language=javascript src=includes/list.js></script>";
    $cat .= "<script language=javascript>";
    $catList = "<option value=0></option>";
    $cat .= "var listB = new DynamicOptionList(\"cat_id_sub\",\"cat_id\");";
    $result = mysql_query("select menu_id, menu_name from menu where sub = '0' order by ord");
    while(list($menu_id, $menu_name) = mysql_fetch_row($result)){
        $selected = '';
        if ($menu_id == $menu_id1){ $selected = "selected"; }
        $result55 = mysql_query("select menu_id, menu_name from menu where sub = '$menu_id' order by ord");
        $count = mysql_num_rows($result55);
        if ($count != 0){

            $js .= "listB.addOptions(\"$menu_id\", \" \", \"0\"";
            while(list($menu_id2, $menu_name2) = mysql_fetch_row($result55)){
                $x=0;
                list($checkCount) = mysql_fetch_row(mysql_query("select count(*) from menu where sub = '$menu_id2' and menu_id = '$menu_id1'"));
                if ($checkCount == 1){ $selected = "selected"; $x=1; }
                if ($menu_id2 != $menu_id1){ $js .= ",\"$menu_name2\", \"$menu_id2\""; }
                else { $selected = "selected"; }
                if ($x==1){ $djs .= "listB.setDefaultOption(\"$menu_id\", \"$menu_id2\");";}
            }
            $js .= ");";
        }
        if ($menu_id != $menu_id1){ $catList .= "<option value=$menu_id $selected>$menu_name</option>"; }
    }
    $cat .= $js;
    $cat .= $djs;
    $cat .= "</script>";
    $cat .= "<select name=cat_id onChange=\"listB.populate()\">$catList</select>";
    $cat .= "<select name=cat_id_sub><script language=JavaScript>listB.printOptions();</script></select>";
    $cat .= "<script language=javascript>listB.init(document.forms[0]);</script>";
    return $cat;
}

function createFontForm(){

    $size = array(small,large,huge);
    $color = array(red,black,white,blue,yellow,green,orange,gray);
    $face = array(arial,times,verdana,wingdings,courier);

    sort($face);
    sort($color);

    $form = "<b>Font </b><select name=fontSize><option value='' selected>Size</option>";
    foreach($size as $s){
        $form .= "<option value='$s'>$s</option>";
    }
    $form .= "</select> <select name=fontColor><option value='' selected>Color</option>";
    foreach($color as $s){
        $form .= "<option value=$s>$s</option>";
    }
    $form .= "</select> <select name=fontFace><option value='' selected>Font</option>";
    foreach($face as $s){
        $form .= "<option value=$s>$s</option>";
    }
    $form .= "</select>";
    $form .= " <input type=button value='Change Font' onClick='changeFont()'>";
    return $form;
}

function pageListing(){
    global $siteURL;
    $result = mysql_query("select page_id, title, page_index from pages order by title");
    while(list($page_id, $title, $page_index) = mysql_fetch_row($result)){
        $menu = '';
        $link = "index.php?id=$page_id";
        list($menu_id, $menu_name, $sub) = mysql_fetch_row(mysql_query("select menu_id, menu_name, sub from menu where link = '$link'"));
        if ($sub != '' && $sub != 0){
            list($menu_name1, $sub1) = mysql_fetch_row(mysql_query("select menu_name, sub from menu where menu_id = '$sub'"));
            if ($sub1 != '' && $sub1 != 0){
                list($menu_name2) = mysql_fetch_row(mysql_query("select menu_name from menu where menu_id = '$sub1'"));
                $menu = "$menu_name2 : ";
            }
            $menu = $menu . "$menu_name1 : ";
        }
        $menu = $menu . "$menu_name";
        $text .= "<tr onMouseOver=\"style.backgroundColor='#B5C1DC';\" onmouseout=\"style.backgroundColor='#FFFFFF';\" bgcolor=#ffffff>";
        $text .= "<td class=hover>$title</td><td class=hover>$menu</td>";
        $text .= "<td class=hover><a href=$siteURL/index.php?id=$page_id target=new><img src=images/_page.gif border=0 alt='View'></a> <a href=javascript:Start('page.php?action=modify&page_id=$page_id')><img src=images/bedit.gif alt='Modify' border=0></a> <a href=javascript:confirmDelete('page.php?action=delete&page_id=$page_id')><img src=images/bdelete.gif alt='Delete' border=0></a></td>";
        $text .= "</tr>";
    }
    return $text;
}

function userSelect(){

    $text .= "<tr><form><td class=main>View User: <select name=site onChange=formHandler(this.form)>";
    $text .= "<option value=''></option>";
    $result = mysql_query("select user_id, first_name, last_name from users order by first_name");
    while(list($user_id, $first_name, $last_name) = mysql_fetch_row($result)){
        $text .= "<option value=user.php?action=detail&user_id=$user_id>$first_name $last_name</option>";
    }
    $text .= "</select></td></form></tr>";
    return $text;
}

function findUserInfo($user_id){

    list($username, $first_name, $last_name, $email, $admin, $suspend) = mysql_fetch_row(mysql_query("select username, first_name, last_name, email, admin, suspend from users where user_id = '$user_id'"));
    $userinfo[] = $user_id;    //0
    $userinfo[] = $username;   //1
    $userinfo[] = $first_name; //2
    $userinfo[] = $last_name;  //3
    $userinfo[] = $email;      //4
    $userinfo[] = $admin;      //5
    $userinfo[] = $suspend;    //6
    return $userinfo;
}

function logout($userinfo, $host){

    setcookie("PXL", '', time() - 60, '', $host);
    addLog("Logged Out", $userinfo[0], $userinfo[0]);
    header("Location: login.php?code=l");

}

?>
