<?php
#$Id: var.inc.php,v 1.2 2003/05/27 17:19:39 ryan Exp $
$filter = array("on" => "1", "off" => "0");
$prog_title = "X Lite";
$prog_version = "1.0.0";

$file_types = array(".gif" => "image/gif", ".jpg" => "image/jpeg", ".png" => "image/png", ".jpg" => "image/pjpeg");
$loginCodes["s"] = "Account Suspended";
$loginCodes["i"] = "Invalid Login";
$loginCodes["a"] = "Unauthorized Action";
$loginCodes["l"] = "Logged Out";


define("FATAL",E_USER_ERROR);
define("ERROR",E_USER_WARNING);
define("WARNING",E_USER_NOTICE);
error_reporting(FATAL | ERROR | WARNING);
$old_error_handler = set_error_handler("onError");

//Error messages
$errorHeader["401"] = "<tr><td class=mainbold>Error 401 - UnAuthorized Access</td></tr>";
$errorHeader["403"] = "<tr><td class=mainbold>Error 403 - Forbidden</td></tr>";
$errorHeader["404"] = "<tr><td class=mainbold>Error 404 - Not Found</td></tr>";
$errorHeader["500"] = "<tr><td class=mainbold>Error 500 - Internal Server Error</td></tr>";
$errorHeader["503"] = "<tr><td class=mainbold>Error 503 - Service Unavailable</td></tr>";

$errorMessage["401"] = "<tr><td class=main>You do not have permission to access this document.  Please check your URL and try again.</td></tr>";
$errorMessage["403"] = "<tr><td class=main>This page and/or directory is forbidden.  Please check your URL and try again.</td></tr>";
$errorMessage["404"] = "<tr><td class=main>This page and/or directory could not be found.  Please check your URL and try again.</td></tr>";
$errorMessage["500"] = "<tr><td class=main>There was an Server Error.  Please email us using the link below and indicated what you were attempted to do when you encountered this page.</td></tr>";
$errorMessage["503"] = "<tr><td class=main>There was an Server Error.  The server is currently unavailable.  We are working to restore it.  Please check back.</td></tr>";

$errorFooter = "<tr><td class=main>If you feel you have reached this message in error please contact <a href=mailto:$webmasterEmail>$webmasterEmail</a>.  <a href=$siteURL>Click Here to Return to $siteName</a></td></tr>";


?>
