<?php
#$Id: functions.inc.php,v 1.3 2003/05/30 14:13:11 ryan Exp $
require('admin/includes/config.inc.php');
require('admin/includes/var.inc.php');

function connectdb() {
    //Connects to a given database//
    global $dbserver;
    global $dbuser;
    global $dbpass;
    global $database;

    mysql_connect("$dbserver", "$dbuser", "$dbpass");
    mysql_select_db("$database");
}

function getStartTime(){

    $mtime = microtime();
    $mtime = explode(" ",$mtime);
    $mtime = $mtime[1] + $mtime[0];
    $starttime = $mtime;
    return $starttime;
}

function getEndTime($starttime, $p, $q){
    $mtime = microtime();
    $mtime = explode(" ",$mtime);
    $mtime = $mtime[1] + $mtime[0];
    $endtime = $mtime;
    $totaltime = ($endtime - $starttime);
    timerLog($totaltime, $p, $q);
}

function timerLog($total, $p, $q){
    $current_date_time = date("M-d-y H:i:s");
    $writefile = "admin/logs/timer.log";
    if (file_exists($writefile)){ $fp = fopen( $writefile, 'a'); }
    else { touch($writefile); $fp = fopen( $writefile, 'w' ); }
    fwrite( $fp, "$current_date_time :: $total :: $p?$q \r\n");
    fclose($fp);
}

function onError($errno, $errstr, $errfile='', $errline=''){

    $current_date_time = date("M-d-y H:i:s");
    global $siteName;
    global $webmasterEmail;
    global $textArray;
    $writefile = "admin/logs/error.log";
    $headers = "From: $siteName Error Mailer <$webmasterEmail>\r\n";
    $headers .= "X-Sender: <$webmasterEmail>\r\n";
    $headers .= "X-Mailer: PHP\r\n";
    $headers .= "X-Priority: 1\r\n";
    $headers .= "Reply-To: $webmasterEmail\r\n";
    if ($errno == FATAL){
        $message = "FATAL [$errno] $errstr";
        $message .= " :: ".$errline." :: ".$errfile." :: " . time() . "\r\n";
        $message .= ", PHP ".PHP_VERSION." (".PHP_OS.")\r\n";
        $die=2;
    }
    else if ($errno == ERROR){
        $message =  "ERROR [$errno] $errstr :: ".$errline." :: ".$errfile." :: " . time() . "\r\n";
        $die=1;
    }
    else if ($errno == WARNING || $errno == "2"){
        $message = "WARNING [$errno] $errstr :: ".$errline." :: ".$errfile." :: " . time() . "\r\n";
        $die=1;
    }
    //else {
    //    $message = "Unkown error type: [$errno] $errstr :: ".$errline." :: ".$errfile." :: " . time() . "\r\n";
    //}
    if ($die == 1 || $die == 2){
        if (file_exists($writefile)){ $fp = fopen( $writefile, 'a'); }
        else { touch($writefile); $fp = fopen( $writefile, 'w' ); }
        fwrite( $fp, $message);
        fclose($fp);
        $message .= "\r\n" . $textArray['Do Not Reply to this Message'];
        mail($addressemail, $textArray['An Error Occured'] . " ($siteName)", $message, $headers);

        if ($die == 2){
            $diemessage = "<font face=arial size=2 color=red>" . $textArray['An error has occured.  It has been loged and the Webmaster has been notified.'] . "</font><p>";
            $diemessage .= "<font face=arial size=2>$errstr</font>";

            die($diemessage);
        }
    }
}

function insertStats($agent, $ref, $ip, $host, $id){
    global $siteURL;

    if (ereg("MSIE", $agent)){ $browser = "MSIE"; }
    else if (ereg("Nav", $agent) || ereg("Gold", $agent) || ereg("X11", $agent) || ereg("Mozilla", $agent) || ereg("Netscape", $agent) && (!ereg("MSIE", $agent)) && (!ereg("Konqueror", $agent))){ $browser = "Netscape"; }
    else if (ereg("Lynx", $agent)){ $browser = "Lynx"; }
    else if (ereg("Opera", $agent)){ $browser = "Opera"; }
    else if (ereg("WebTV", $agent)){ $browser = "WebTV"; }
    else if (ereg("Konqueror", $agent)){ $browser = "Konqueror"; }
    else if ((eregi("bot", $agent)) || (ereg("Google", $agent)) || (ereg("Slurp", $agent)) || (ereg("Scooter", $agent)) || (eregi("Spider", $agent)) || (eregi("Infoseek", $agent))){ $browser = "Bot"; }
    else { $browser = "Other"; }

    if(ereg("Win", $agent)){ $os = "Windows"; }
    else if((ereg("Mac", $agent)) || (ereg("PPC", $agent))){ $os = "Mac"; }
    else if(ereg("Linux", $agent)){ $os = "Linux"; }
    else if(ereg("FreeBSD", $agent)){ $os = "FreeBSD"; }
    else if(ereg("SunOS", $agent)){ $os = "SunOS"; }
    else { $os = "Other"; }

    mysql_query("update stats set count=count+1 where (type = '4' and name = 'pageviews') or (name = '$browser' and type = '3') or (name = '$os' and type = '0') or (name = '$id' and type = '1')") or die(mysql_error());
    $refCount = substr_count($ref, $host);
    if ($ref != '' && $refCount == 0){
        $ref = str_replace("http://", '', $ref);
        $result = mysql_query("select count(*) from stats where type = '2' and name = '$ref'");
        list($c) = mysql_fetch_row($result);
        if ($c > 0){ mysql_query("update stats set count=count+1 where type = '2' and name = '$ref'"); }
        else { mysql_query("insert into stats values ('', '2', '$ref', '1')"); }
    }

}

function createMenu(){
    $menu = "MENU_ITEMS0 = [";
    $result = mysql_query("select menu_id, menu_name, link from menu where sub = '0' order by ord");
    while(list($menu_id, $menu_name, $link) = mysql_fetch_row($result)){
        $menu .= "['$menu_name', '$link',";
        $result2 = mysql_query("select menu_id, menu_name, link from  menu where sub = '$menu_id' order by ord");
        $count = mysql_num_rows($result2);
        if ($count > 0){
            while(list($id2, $name2, $link2) = mysql_fetch_row($result2)){
                $menu .= "['$name2', '$link2',";
                $result3 = mysql_query("select menu_name, link from  menu where sub = '$id2' order by ord");
                $count1 = mysql_num_rows($result3);
                if ($count1 > 0){
                    while(list($name3, $link3) = mysql_fetch_row($result3)){
                        $menu .= "['$name3', '$link3'],";
                    }
                    $menu = substr($menu, 0, strlen($menu)-1);
                    $menu .= "],";
                }
                else {
                    $menu = substr($menu, 0, strlen($menu)-1);
                    $menu .= "],";
                }
            }
        }
        $menu = substr($menu, 0, strlen($menu)-1);
        $menu .= "],";
    }
    $menu = substr($menu, 0, strlen($menu)-1);
    $menu .= "];";
    return $menu;
}

function contact($id, $name='', $email='', $url='', $comments=''){
    global $siteName;
    global $webmasterEmail;
    global $textArray;
    if ($name != '' && $email != ''){
        $headers = "From: $name <$email>\r\n";
        $headers .= "X-Sender: <$email>\r\n";
        $headers .= "X-Mailer: PHP\r\n";
        $headers .= "X-Priority: 3\r\n";
        $headers .= "Reply-To: $email\r\n";
        $message = $comments;
        mail($email, "$siteName " . $textArray['Contact Form Submission'], $message, $headers);
        $text = $textArray['Your email has been sent.  Thank you for contacting'] . " $siteName";
        return $text;
    }
    else {
        include("formscript.php");
        $text = "<table border=0 cellpadding=0 cellspacing=1 width=95% class=bg align=center>";
        $text .= "<tr><td colspan=2 class=title align=center>" . $textArray['Contact'] . " $siteName</td></tr>";
        $text .= "<tr><td width=100% class=main><table border=0 cellpadding=2 cellspacing=0 align=center width=100%>";
        $text .= "<form method=post action=index.php?id=$id&action=contact onsubmit=\"return validateForm(this)\">";
        $text .= "<tr><td colspan=2 class=main>";
        $text .= "<tr><td align=right class=mainbold>" . $textArray['Name'] . "<font color=red>*</font> : </td>";
        $text .= "<td align=left class=main><input type=text size=43 name=emailname value=''></td></tr>";
        $text .= "<tr><td align=right class=mainbold>" . $textArray['Email'] . "<font color=red>*</font> : </td>";
        $text .= "<td align=left class=main><input type=text size=43 name=email value=''></td></tr>";
        $text .= "<tr><td align=right class=mainbold>" . $textArray['Website'] . " : </td>";
        $text .= "<td align=left class=main><input type=text value='http://' size=43 name=url></td></tr>";
        $text .= "<tr><td align=right class=mainbold valign=top>" . $textArray['Comments'] . " : </td>";
        $text .= "<td align=left class=main><textarea name=comments cols=43 rows=15></textarea></td></tr>";
        $text .= "<tr><td align=center colspan=2 class=main><input type=submit value=" . $textArray['Send'] . "><br><font color=red>*</font>" . $textArray['required'] . "</td></tr>";
        $text .= "</form></table></td></tr></table>";

        $text .= "<script Language=JavaScript>";
        $text .= "function validateForm(theForm)";
        $text .= "{";
        $text .= "    if (!validRequired(theForm.emailname,\"" . $textArray['Name'] . "\"))";
        $text .= "        return false;";
        $text .= "    if (!validEmail(theForm.email,\"" . $textArray['Email'] . "\",true))";
		$text .= "        return false;";
        $text .= "    return true;";
        $text .= "}";
        $text .= "</script>";
        return $text;
    }

}


function siteSearch($id, $keywords='', $confirm=''){
    global $textArray;
    if ($confirm == 1){
        global $date_format;

        $version = mysql_get_server_info();
        $version = substr($version, 0, 1);


        $search = siteSearch($id, $keywords, '');
        $keywords = "%" . $keywords . "%";
        if ($version == "4"){
            $result = mysql_query("select page_id, title, body from pages where match(title, body) against ('$keywords' in boolean mode)");
            $result2 = mysql_query("select news_id, title, post, date from news where match(title, post) against ('$keywords' in boolean mode)");
        }
        else {
            $result = mysql_query("select page_id, title, body from pages where match(title, body) against ('$keywords')");
            $result2 = mysql_query("select news_id, title, post, date from news where match(title, post) against ('$keywords')");
        }
        $count = mysql_num_rows($result);
        $count1 = mysql_num_rows($result2);

        $text .= "<table border=0 cellpadding=1 cellspacing=1 width=95% align=center class=bg>";
        $text .= "<tr><td class=title>" . $textArray['Search Results'] . "</td></tr></table>";
        $text .= "<table border=0 cellpadding=1 cellspacing=1 width=95% align=center>";
        $text .= "<tr><td class=main colspan=2>$count " . $textArray['Pages'] . " " . $textArray['and'] . " $count1 " . $textArray['News Stories'] . " " . $textArray['found'] . "</td></tr>";
        $text .= "<tr><td class=main>";

        if ($count == 0 && $count1 == 0){
            $text .= "<table border=0 cellpadding=0 cellspacing=0 width=100% align=center><tr><td class=main>" . $textArray['No Results Found'] . "</td></tr></table>";
        }
        else {
            $text .= "<table border=0 cellpadding=0 cellspacing=0 width=95% align=center>";
            while(list($page_id, $title, $body) = mysql_fetch_row($result)){
                $pos = strpos($body, $find);
                $len = strlen($find);
                $body = substr($body, $pos - 25, $pos + $len + 25);
                $text .= "<tr><td class=main><b>" . $textArray['Page']  . " : <a href=index.php?id=$page_id>$title</a></b><br>$body</td></tr>";
            }
            while(list($news_id, $title, $body, $date) = mysql_fetch_row($result2)){
                $pos = strpos($body, $find);
                $len = strlen($find);
                $body = substr($body, $pos - 25, $pos + $len + 25);
                $date = date($date_format, $date);
                $text .= "<tr><td class=main><b>" . $textArray['News Story'] . ": <a href=index.php?id=$id&news_id=$news_id>$title</a></b> <font size=1>$date</font><br>$body</td></tr>";
            }
            $text .= "</table>";
        }
        $text .= "</td><td class=main valign=top>$search</td></tr>";
        //$text .= "<tr><td class=main colspan=2>$showing $more</td></tr>";
        $text .= "</table>";
    }
    else {

        global $siteName;
        $text = "<table border=0 cellspacing=1 cellpadding=0 width=250 class=bg align=center>";
        $text .= "<tr><td class=title align=center>$siteName " . $textArray['Search'] . "</td></tr>";
        $text .= "<tr><td class=main>";
        $text .= "<table border=0 cellpadding=0 cellspacing=0 width=95% align=center>";
        $text .= "<form method=post action=index.php?action=search&id=$id&confirm=1>";
        $text .= "<tr><td align=center class=main>" . $textArray['Search'] . ": <input type=text name=keywords size=20 value='$keywords'></td>";
        $text .= "</tr>";
        $text .= "<tr>";
        $text .= "<td align=center class=main><input type=submit value=" . $textArray['Search'] . "></td>";
        $text .= "</tr>";
        $text .= "</table></td></form></tr></table><p>";
    }
    return $text;
}

function showNews($id, $news_id=''){
    global $date_format;
    global $number_of_news;
    global $headlines;
    global $textArray;
    if ($news_id != ''){
        list($title, $post, $date) = mysql_fetch_row(mysql_query("select title, post, date from news where news_id = '$news_id'"));
        $title = stripslashes($title);
        $post = stripslashes($post);
        $date = date($date_format, $date);
        $text = getNewsTemplate($title, $post, $date);
    }
    else {
        if ($headlines == 1){ $text = "<b>" . $textArray['News Stories'] . "</b><br><br>"; }
        $result = mysql_query("select news_id, title, post, date from news order by news_id desc limit 0,$number_of_news");
        while(list($news_id, $title, $post, $date) = mysql_fetch_row($result)){
            $title = stripslashes($title);
            $post = stripslashes($post);
            $date = date($date_format, $date);
            if ($headlines == 0){ $text .= getNewsTemplate($title, $post, $date); }
            else { $text .= getHeadlineTemplate($id, $news_id, $title, $date); }
            $text .= "<p>";
        }
    }
    $text .= "<p>";
    $text .= "<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td class=main align=right><a href=index.php?id=$id&action=browse>" . $textArray['older news stories'] . "...</a></td></tr></table>";
    return $text;
}

function getNewsTemplate($title, $post, $date){

    $text .= "<table width=95% cellspacing=1 cellpadding=0 border=0 align=center class=bg>";
    $text .= "<tr>";
    $text .= "<td align=left class=title>$date - $title</td></tr></table>";
    $text .= "<table border=0 cellpadding=2 cellspacing=0 width=95% align=center><tr>";
    $text .= "<td colspan=2 align=left class=main>";
    $text .= "$post";
    $text .= "</td>";
    $text .=  "</tr></table><br><br>";
    return $text;
}

function getHeadlineTemplate($id, $news_id, $title, $date){

    $text = "<table width=95% cellspacing=1 cellpadding=1 border=0 class=bg align=center>";
    $text .= "<tr><td class=main>";
    $text .= "<a href=index.php?id=$id&news_id=$news_id>$title</a> - $date";
    $text .= "</td></tr></table>";
    return $text;
}

function browseNews($id, $limit){
    global $date_format;
    global $textArray;
    $setnum = 25;

    if ($limit == ''){ $limit = "0"; }
    $result = mysql_query("select news_id from news");
    $number = mysql_num_rows($result);
    $result = mysql_query("select news_id, title, post, date from news order by news_id desc limit $limit,$setnum");

    $show = $limit + $setnum;
    if ($show > $number){ $show = $number; }
    if ($limit == '0'){ $limit1 = 1; }
    else { $limit1 = $limit; }
    $showing = $textArray['Showing'] . " $limit1 - $show ($number " . $textArray['Total'] . ")";

    if ($number == 0){ $text = "<table border=0 cellpadding=0 cellspacing=0 align=center><tr><td class=attn2 align=center>" . $textArray['No Results Found'] . "</td></tr></table>"; }
    else {
        //$more = "Page: ";
        if ($limit != '0'){
            $new = $limit - $setnum;
            if ($new < 0){ $new = 0; }
            $more .= "<a class=links href=index.php?id=$id&limit=0&action=browse><<</a> ";
            $more .= "<a class=links href=index.php?id=$id&limit=$new&action=browse>" . $textArray['Previous'] . "</a>";
        }

        $y=0;
        for($x=0; $x < $number; $x += $setnum){
            if ($x == $limit){
                $save = $y;
                break;
            }
            $y++;
        }

        $a=1;
        $stopFlag=0;
        for($x=0; $x < $number; $x += $setnum){
            if ($save < 5){
                $st = 0;
                $en = 10;
            }
            else {
                $st = $save - 4;
                $en = $save + 6;
            }

            if ($limit == $x){
                $more .= " $a ";
                $stopFlag=1;
            }
            else if ($x > ($number - $setnum) && $stopFlag == 0){
                $more .= " $a";
            }
            else {
                $more .= " <a class=links href=index.php?id=$id&limit=$x&action=browse>$a</a> ";
            }
            $a++;
        }
        if ($number > ($limit + $setnum)){
            $new = $limit + $setnum;
            $end = $number - $setnum;
            $more .= "<a class=links href=index.php?id=$id&limit=$new&action=browse>" . $textArray['Next'] . "</a>";
            $more .= "<a class=links href=index.php?id=$id&limit=$end&action=browse>>></a>";
        }
        $search = siteSearch($id);
        $text .= "<table border=0 cellpadding=1 cellspacing=1 width=95% align=center class=bg>";
        $text .= "<tr><td class=title>" . $textArray['News Stories'] . "</td></tr></table>";
        $text .= "<table border=0 cellpadding=1 cellspacing=1 width=95% align=center>";
        $text .= "<tr><td class=main colspan=2>$showing $more</td></tr>";
        $text .= "<tr><td class=main>";
        while(list($news_id, $title, $post, $date) = mysql_fetch_row($result)){
            $title = stripslashes($title);
            $post = stripslashes($post);
            $date = date($date_format, $date);
            $post = substr($post, 0, 50) . "...";
            $text .= "<table border=0 cellpadding=0 cellspacing=1 class=outline width=100%>";
            $text .= "<tr><td class=main><b><a href=index.php?id=$id&news_id=$news_id>$title</a></b> - $date<br>$post</td></tr>";
            $text .= "</table><br>";
        }
        $text .= "</td><td class=main valign=top>$search</td></tr>";
        $text .= "<tr><td class=main colspan=2>$showing $more</td></tr>";
        $text .= "</table>";
    }
    return $text;
}

function publicstats($id){
    global $textArray;
    global $siteName;
    global $barColor;
    list($total) = mysql_fetch_row(mysql_query("select count from stats where type = '4'"));
    $text = "<table border=0 cellpadding=0 cellspacing=1 width=400 align=center class=bg>";
    $text .= "<tr><td class=title align=center colspan=2>$site_title " . $textArray["Stats"] . "</td></tr></table><p>";
    $result = mysql_query("select name, count from stats where type = '0'");
    $oscount=0;
    $hold = array();
    while(list($name, $count) = mysql_fetch_row($result)){
        $oscount += $count;
        $hold[] = array($name, $count);
    }
    $text .= "<table border=0 cellpadding=0 cellspacing=1 width=400 align=center class=bg>";
    $text .= "<tr><td class=title align=center colspan=2>" . $textArray["Operating System"] . "</td></tr></table><table border=0 cellpadding=1 cellspacing=0 width=400 align=center>";
    $s = $oscount/100;
    foreach($hold as $h){
        $perc = ($h[1] / $s);
        $width = $perc * 2;
        $perc = round($perc, 2);
        $text .= "<tr><td align=left class=main><img src=images/$h[0].gif alt=$h[0]> $h[0]</td><td class=main><img src=images/$barColor.gif width=$width alt='$h[0]' height=10> $perc % ($h[1])</td></tr>";
    }
    $text .= "</table><p>";

    $result = mysql_query("select name, count from stats where type = '3'");
    $oscount=0;
    $hold = array();
    while(list($name, $count) = mysql_fetch_row($result)){
        $oscount += $count;
        $hold[] = array($name, $count);
    }

    $text .= "<table border=0 cellpadding=0 cellspacing=1 width=400 align=center class=bg>";
    $text .= "<tr><td class=title align=center colspan=2>" . $textArray["Browsers"] . "</td></tr></table><table border=0 cellpadding=1 cellspacing=0 width=400 align=center>";
    $s = $oscount/100;
    foreach($hold as $h){
        $perc = ($h[1] / $s);
        $width = $perc * 2;
        $perc = round($perc, 2);
        $text .= "<tr><td align=left class=main><img src=images/$h[0].gif alt=$h[0]> $h[0]</td><td class=main><img src=images/$barColor.gif width=$width alt='$h[0]' height=10> $perc % ($h[1])</td></tr>";
    }
    $text .= "</table><p>";

    $result2 = mysql_query("select count(news_id) from news");
    list($temp2) = mysql_fetch_row($result2);
    $text .= "<table border=0 cellpadding=0 cellspacing=1 width=400 align=center class=bg>";
    $text .= "<tr><td class=title align=center colspan=2>" . $textArray["Other Stats"] . "</td></tr></table><table border=0 cellpadding=1 cellspacing=0 width=400 align=center>";
    $text .= "<tr><td align=left class=main>" . $textArray["Pageviews"] . "</td>";
    $text .= "<td align=left class=main>$total</td></tr>";
    $text .= "<tr><td align=left class=main>" . $textArray["News Published"] . "</td>";
    $text .= "<td align=left class=main>$temp2</td></tr>";
    $text .= "</table>";
    return $text;
}















